<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format">
	
<xsl:template match="/">
  <html>
    <xsl:apply-templates/>
  </html>
</xsl:template>

<xsl:template match="head">
  <head>
    <xsl:apply-templates/>
  </head>
  <style>
    body { font-family: verdana, arial, helvetica, sans-serif; }
    .tableheading { font-family: verdana, arial, helvetica, sans-serif; font-size: 10pt; font-weight: bold; }
    .tablecontent { font-family: verdana, arial, helvetica, sans-serif; font-size: 10pt; }
    .tinytext { font-family: verdana, arial, helvetica, sans-serif; font-size: 8pt; }
  </style>
</xsl:template>

<xsl:template match="title">
  <title><xsl:value-of select="."/></title>
</xsl:template>

<xsl:template match="/form">
  <body>
    <div align="center">
    <table cellspacing="0" cellpadding="0" border="0" width="720">
      <tr>
        <td height="50"><img src=".\images\logo.gif" width="220" height="50"/></td>
      </tr>
      <tr>
        <td height="6" valign="bottom"><img src=".\images\1px.gif" height="1" width="720"/></td>
      </tr>
      <tr>
        <td align="center"><img src=".\images\abc.gif" vspace="18"/></td>
      </tr>
      <tr>
        <td align="center">
        <xsl:element name="form">
          <xsl:attribute name="method">POST</xsl:attribute>
          <xsl:attribute name="action"><xsl:value-of select="@action"/></xsl:attribute> 
          <table cellpadding="3" cellspacing="1" border="0" bgcolor="#000000">
            <tr>
              <td bgcolor="#C0C0C0" colspan="2" align="center"><font class="tableheading"><xsl:value-of select="/form/head/title/."/></font></td>
            </tr>
            <tr>
              <td bgcolor="#FFFFFF">
                <table cellpadding="3" cellspacing="0" border="0">
                  <xsl:apply-templates/>
                  <tr>
                    <td colspan="2" align="center"><input type="submit" value="Submit" name="btnSubmit"/></td>
                  </tr>
                </table>
              </td>
            </tr>
          </table>
        </xsl:element>
        </td>
      </tr>
      <tr>
        <td align="right"><font  class="tinytext">&#169;2000 Valtech UK Ltd</font></td> 
      </tr>
    </table>
    </div>
  </body>
</xsl:template>

<xsl:template match="input">
  <tr>
    <td><font  class="tablecontent"><xsl:value-of select="@name"/>: </font></td>
    <td>
      <xsl:element name="input">
        <xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
        <xsl:attribute name="type"><xsl:value-of select="@type"/></xsl:attribute>
	<xsl:attribute name="value"><xsl:value-of select="@value"/></xsl:attribute>
	</xsl:element>
    </td>
  </tr>
</xsl:template>

</xsl:stylesheet>
