



package com.valtech.bootcamp.carRental.business.customer.impl;

import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import java.rmi.RemoteException;
import javax.ejb.EJBException;
import javax.ejb.CreateException;
import java.sql.SQLException;
import javax.ejb.FinderException;
import com.valtech.bootcamp.carRental.business.customer.CustomerHome;
import com.valtech.bootcamp.carRental.business.customer.Customer;
import com.valtech.bootcamp.carRental.business.customer.CustomerStateHolder;


/**
 *
 * Implementation for Customer Entity CMP Bean
 * @ejbHome CustomerHome
 * @ejbRemote Customer
 * @author Valtech UK<br><br>
 */



public class CustomerBean implements EntityBean
{
    private EntityContext ctx;

   /**
    * the customer name
    */
    public String name;

    /**
     * the customer address
     */
    public String address;

    /**
     * the customer address
     */
    public String cardNo;




    public void setEntityContext(EntityContext context) //throws RemoteException, EJBException
    {
        ctx = context;
    }

    /**
     * returns a CustomerStateHolder containing all Customer attributes
     */
    public CustomerStateHolder getCustomerStateHolder()
    {

        CustomerStateHolder csh = new CustomerStateHolder(name, address, cardNo);
        return csh;
    }


     /*
      * Sets Customer attributes to the values passed in as attributes
      * of the state holder.
      * @param csh The state holder object containing customer details
      */
     public void setCustomerStateHolder(CustomerStateHolder csh)
     {

        setName(csh.getName());
        setAddress(csh.getAddress());
        setCardNo(csh.getCardNo());
     }




    public EntityContext getEntityContext()
    {
        return ctx;
    }


    public void unsetEntityContext() //throws RemoteException, EJBException
    {
        ctx = null;
    }

    public void ejbActivate() //throws RemoteException, EJBException
    {
    }

    public void ejbPassivate() //throws RemoteException, EJBException
    {
    }

    public void ejbRemove() //throws RemoteException, EJBException
    {
    }

    public void ejbStore() //throws RemoteException, EJBException
    {
    }

    public void ejbLoad() //throws RemoteException, EJBException
    {
    }

    public String ejbCreate(CustomerStateHolder csh) //throws CreateException, EJBException, RemoteException, SQLException
    {
        setCustomerStateHolder(csh);
        return null;
    }

    public void ejbPostCreate(CustomerStateHolder csh) { } //throws CreateException, EJBException, RemoteException, SQLException { }
 /*
    public Customer findByPrimaryKey(CustomerPK pk) throws CreateException, EJBException, RemoteException
    {
        return null;
    }
 */


    /**
     * Setter for the name
     */
    private void setName(String name)
    {
        this.name = name;
    }

    /**
     * Setter for the address
     */
    public void setAddress(String address)
    {
        this.address = address;
    }

    /**
     * Setter for the card number
     */
    public void setCardNo(String cardNo)
    {
        this.cardNo = cardNo;
    }
}
