/* Generated by Together */

package com.valtech.bootcamp.carRental.service.reservationAgent.impl;

import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import java.rmi.RemoteException;
import javax.ejb.*;
import com.valtech.bootcamp.carRental.service.reservationAgent.ReservationAgentHome;
import com.valtech.bootcamp.carRental.service.reservationAgent.ReservationAgent;
import com.valtech.bootcamp.carRental.business.customer.*;


import java.sql.*;
import com.valtech.bootcamp.carRental.business.customer.CustomerStateHolder;
import com.valtech.bootcamp.carRental.service.reservationAgent.*;
import com.valtech.bootcamp.carRental.business.reservation.*;
import java.util.*;
import test.valtech.bootcamp.carRental.service.reservationAgent.impl.ReservationAgentBeanTest;
import javax.naming.Context;
import javax.rmi.*;
import javax.naming.InitialContext;


/**
 * The stateless session EJB acting as a facade for the entity CMP.<br><br>
 * @author Valtech UK
 */
public class ReservationAgentBean implements SessionBean
{
    private SessionContext ctx;

    /**
     * @link
     * @shapeType PatternLink
     * @pattern TestCase
     * @clientRole tested
     * @supplierRole tests
     * @hidden
     */
    /*# private ReservationAgentBeanTest _reservationAgentBeanTest; */

    public void setSessionContext(SessionContext context) throws RemoteException, EJBException
    {
        ctx = context;
    }

    public void ejbActivate() throws RemoteException, EJBException
    {
    }

    public void ejbPassivate() throws RemoteException, EJBException
    {
    }

    public void ejbRemove() throws RemoteException, EJBException
    {
    }

    public void ejbCreate() throws CreateException, EJBException, RemoteException
    {
    }


    /**
     * returns a CustomerStateHolder of the customer with the given name.<br>
     * &param name the name of the customer on which the retrieval is based.
     */
    public CustomerStateHolder getCustomer(String name)
    {
        System.setProperty("java.naming.factory.initial","org.jnp.interfaces.NamingContextFactory");
    	System.setProperty("java.naming.provider.url","localhost:1099");

        CustomerStateHolder csh = null;
        try
        {
        	Context initial = new InitialContext();
       		CustomerHome custHome = (CustomerHome)PortableRemoteObject.narrow(initial.lookup("CustomerBean"), CustomerHome.class);
			Customer cust = custHome.findByPrimaryKey(name);

            //gets the CustomerStateHolder for this Customer
            csh = cust.getCustomerStateHolder();
        }
	    catch(FinderException e)
	    {
        	csh = null;
       	}
        catch(EJBException e)
        {
        	//throw e;
        }
        catch(Exception e)
        {
            //e.printStackTrace();
            //throw new EJBException(e);
        }
         return csh;
    }


    /**
     * Sets the customer details.<br>
     * If the customer already exists then an update of the address and card number occurs.<br>
     * If the customer does not exist then the customer details are entered as new.<br>
     * @param csh The state holder holding customer details
     */
    public void setCustomer(CustomerStateHolder csh)
    {
		System.setProperty("java.naming.factory.initial","org.jnp.interfaces.NamingContextFactory");
    	System.setProperty("java.naming.provider.url","localhost:1099");
        CustomerHome custHome = null;

        try
        {
        	Context initial = new InitialContext();
        	custHome = (CustomerHome)PortableRemoteObject.narrow(initial.lookup("CustomerBean"), CustomerHome.class);
			Customer custCreate = (Customer)custHome.findByPrimaryKey(csh.getName());
            custCreate.setAddress(csh.getAddress());
            custCreate.setCardNo(csh.getCardNo());
        }
        catch(FinderException fe)
        {
            try
            {
         	Customer custCraete = custHome.create(csh);
            }
             catch(Exception e)
        	{
            	e.printStackTrace();
        	}
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }

    /**
     * Sets a reservation.
     * @param reservation a state holder containing reservation attributes to be set.
     */
    public String setReservation(ReservationStateHolder reservation)
    {
        String resID=null;


        System.setProperty("java.naming.factory.initial","org.jnp.interfaces.NamingContextFactory");
    	System.setProperty("java.naming.provider.url","localhost:1099");

        try
        {
            Context initial = new InitialContext();
            ReservationHome resHome = (ReservationHome)PortableRemoteObject.narrow(initial.lookup("ReservationBean"), ReservationHome.class);
            resID=getUniqueResNo();

            //re-setting the reservation number here
            reservation.setReservationNumber(resID);
	    	Reservation r=resHome.create(reservation);

        }
        catch(Exception e)
       	{
            e.printStackTrace();
       	}

        return resID;
    }


    /**
     * Looks up on the reservation number parameter passed in and constructs and returns a state holder.
     * containing all the details of the reservation<br>
     * @param resNum the reservation number
     */
    public ReservationStateHolder getReservation(String resNum)
    {

        Reservation retrieved=null;
 		ReservationStateHolder toreturn=null;

        try{
            Context initial = new InitialContext();

            //get the home interface
            ReservationHome resHome = (ReservationHome)PortableRemoteObject.narrow(initial.lookup("ReservationBean"), ReservationHome.class);

            retrieved=resHome.findByPrimaryKey(resNum);
            toreturn= retrieved.getReservationStateHolder();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }

        return toreturn;
    }



    /**
     * Generates a unique number to be used as the primary key.
     */
    private String getUniqueResNo()
    {

        System.setProperty("java.naming.factory.initial","org.jnp.interfaces.NamingContextFactory");
    	System.setProperty("java.naming.provider.url","localhost:1099");

        int hivalue=0;
        try
        {
        	Context initial = new InitialContext();
            	ReservationHome resHome = (ReservationHome)PortableRemoteObject.narrow(initial.lookup("ReservationBean"), ReservationHome.class);
            	Collection coll=resHome.findAll();
	        	Iterator it = coll.iterator();

            	while(it.hasNext())
            	{
                	Reservation res=(Reservation)it.next();
					if( hivalue < Integer.parseInt( res.getReservationNumber()) )
                		{
                		hivalue =Integer.parseInt( res.getReservationNumber() );
              		}
            	}
				hivalue ++;
        }
        catch(Exception e)
        {
		e.printStackTrace();
        }
		return(Integer.toString(hivalue));
    }



    /**
     * Removes the customer with the given name.
     */
    public void removeCustomer(String custname)
	{

            System.setProperty("java.naming.factory.initial","org.jnp.interfaces.NamingContextFactory");
    		System.setProperty("java.naming.provider.url","localhost:1099");


            try
            {
            Context initialb = new InitialContext();
            CustomerHome cusHome = (CustomerHome)PortableRemoteObject.narrow(initialb.lookup("CustomerBean"), CustomerHome.class);
			Customer customer = cusHome.findByPrimaryKey(custname);
            customer.remove();
            }
            catch(Exception e)
            {
                e.printStackTrace();
            }
	}


}//end of class
