/* Generated by Together */

package test.valtech.bootcamp.carRental.business.reservation.impl;

import junit.framework.*;
import junit.util.*;
import com.valtech.bootcamp.carRental.business.reservation.impl.ReservationBean;
import com.valtech.bootcamp.carRental.business.reservation.*;
import java.rmi.RemoteException;
import javax.rmi.PortableRemoteObject;
import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.naming.*;
import java.util.Date;


/**
 * Unit test class for the Reservation Bean.<br><br>
 * @author Valtech
 */

public class ReservationBeanTest extends TestCase
 {

  public ReservationBeanTest(String aName){
        super(aName);
  }


   /**
   *
   * A reservation is created and retrieved.<br>
   * Equality test is performed on state holder objects
   */
   public void testReservationBean()
    {

        ReservationStateHolder rshKnown = null;


        System.setProperty("java.naming.factory.initial","org.jnp.interfaces.NamingContextFactory");
    	System.setProperty("java.naming.provider.url","localhost:1099");


       try
        {

            Context initial = new InitialContext();

            /* Note reservation details held as state holder*/
			rshKnown= new ReservationStateHolder("290", "09-11-00", "11-11-00", "APC", "Martin");

			ReservationHome resHome = (ReservationHome)PortableRemoteObject.narrow(initial.lookup("ReservationBean"), ReservationHome.class);

            Reservation newres=resHome.create(rshKnown);

            //retrieval attempt
            Reservation retrieved=resHome.findByPrimaryKey(rshKnown.getReservationNumber());

            ReservationStateHolder retrsh=retrieved.getReservationStateHolder();

            /*equality test between the two state holders*/
            assert(retrsh.equals(rshKnown));

            /*clean up to avoid primary key clashes*/
            resHome.remove(rshKnown.getReservationNumber());
        }
        catch(Exception e)
        {
            System.out.print("Test Error");
            assert(false);
        }

    }//end of method

}//end of class
