/* Generated by Together */

package test.valtech.bootcamp.carRental.service.reservationAgent.impl;

import com.valtech.bootcamp.carRental.service.reservationAgent.impl.ReservationAgentBean;
import com.valtech.bootcamp.carRental.service.reservationAgent.*;
import com.valtech.bootcamp.carRental.business.reservation.*;
import com.valtech.bootcamp.carRental.business.customer.CustomerStateHolder;
import com.valtech.bootcamp.carRental.business.customer.Customer;
import com.valtech.bootcamp.carRental.business.customer.CustomerHome;
import junit.framework.*;
import junit.util.*;
import java.util.Date;
import javax.naming.*;
import javax.rmi.*;



/**
 * Unit test class for the ReservationAgent stateless session EJB.<br>
 * Uses Junit test framework.<br><br>
 * @author Valtech
 */

public class ReservationAgentBeanTest extends TestCase
{





	public ReservationAgentBeanTest(String aName){
        super(aName);
    }

   


   

    public void testSessionBeanCustomer()
    {
        System.setProperty("java.naming.factory.initial","org.jnp.interfaces.NamingContextFactory");
    		System.setProperty("java.naming.provider.url","localhost:1099");

        CustomerStateHolder csh=new CustomerStateHolder("Martin1", "8 Burghley Close","1234454");


        try
        {
        	Context initial = new InitialContext();
        	ReservationAgentHome rah = (ReservationAgentHome)PortableRemoteObject.narrow(initial.lookup("ReservationAgentBean"), ReservationAgentHome.class);

			ReservationAgent ra=rah.create();

        	ra.setCustomer(csh);
        	//customer should now be set


        	//perform retrieval
        	CustomerStateHolder retrieved=ra.getCustomer(csh.getName());

            //test assert
            assert(retrieved.equals(csh));



            //clean up to avoid primary key clash
            Context initialb = new InitialContext();
            CustomerHome cusHome = (CustomerHome)PortableRemoteObject.narrow(initialb.lookup("CustomerBean"), CustomerHome.class);

			cusHome.remove(retrieved.getName());
        }
		catch(Exception e)
        {
            assert(false);
        }

    }//end of method


   /**
    * Creates a reservation and performs a retrieval on the primary key.
    * Two state holders are created and attributes are compared for equality.
    */
    public void testSessionBeanReservation()
    {
        System.setProperty("java.naming.factory.initial","org.jnp.interfaces.NamingContextFactory");
    	System.setProperty("java.naming.provider.url","localhost:1099");

        ReservationStateHolder rsh=new ReservationStateHolder("1000","21-5-00", "23-5-00", "L", "Martin");

        try
        {
           	Context initial = new InitialContext();
        	ReservationAgentHome rah = (ReservationAgentHome)PortableRemoteObject.narrow(initial.lookup("ReservationAgentBean"), ReservationAgentHome.class);


            ReservationAgent ragent=rah.create();

			//key returned
            String key=ragent.setReservation(rsh);
            System.err.print(key);

			ReservationStateHolder retrieved=ragent.getReservation(key);



           /* note that the business logic generates a different primary key so we cannot test on equality
            * on the state holder object
            */
			assert( retrieved.getStartDate().equals(rsh.getStartDate())
                &&  retrieved.getEndDate().equals(rsh.getEndDate())
                &&  retrieved.getCarType().equals(rsh.getCarType())
                &&  retrieved.getCustomerName().equals(rsh.getCustomerName()));

            //clean up tables
            ReservationHome rh=(ReservationHome)PortableRemoteObject.narrow(initial.lookup("ReservationBean"),ReservationHome.class);
            rh.remove(key);
        }
        catch(Exception e)
        {
            assert(false);
        }
    }//end of method





}//end of class
